
// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

var PortServer = null;
var ServerHost = "";
var hostName = "kkmserver.addin.io";
var ServerRun = false;
var ConnectPotRun = false;
var BeforeRequestRun = false;
var Error = "";
var Id = "";
var QueryResponses = new Map();
var TrackingStatus = new Map();
var User = "Admin";
var Pass = "";
var IdAppChrom = "mjeeklofjbnodnnfibjolokichkhcpog";
var IdAppOpera = "dkbekbmeodgkglklclonfbglkbglinlm";
var IdAppFirefox = "f0fc9992-333c-4f09-8b33-f56bc9f3131a";
var ServerInstall = undefined;
var DateReqServerInstall = undefined;
var TimerId = undefined;

//


///////////////////////////////////////////////////////////////////////////
//  Связь с сервером
///////////////////////////////////////////////////////////////////////////

connect();


function connect() {

    // Настройка
    ServerHost = localStorage["AddIn.Server"];
    if (ServerHost == undefined) {
        ServerHost = "AddIn";
    };

    // Запускаем KkmServer
    ServerHost = localStorage["AddIn.Server"];
    if (ServerRun == false && ServerHost == "AddIn") {

        PortServer = browser.runtime.connectNative(hostName);
        PortServer.onDisconnect.addListener(onNativeDisconnected);
        PortServer.onMessage.addListener(onNativeMessage);

        ServerRun = true;
    };

    // Запускаем прослушиватель
    if (ConnectPotRun == false) {
        browser.runtime.onConnect.addListener(onConnectPot);
        ConnectPotRun = true;
    };

    if (BeforeRequestRun == false) {
        BeforeRequestRun = true;
    };

    //browser.webRequest.onBeforeRequest.addListener(onBeforeRequest, { urls: ["*://localhost/*"] }, ["blocking"]);
}


// При ошибке приложения
function onNativeDisconnected() {
    if ('runtime.lastError.message' in browser) {
        Error = browser.runtime.lastError.message;
    } else {
        Error = "onNativeDisconnected";
    }
    console.log("Failed to connect: " + Error);
    port = null;
    //Port.postMessage({ Command: "AddInServerInstall", ServerInstall: undefined });
    if (ServerInstall == undefined && DateReqServerInstall != undefined && (new Date() - DateReqServerInstall) >= 5000) {
        ServerInstall = false;
        DateReqServerInstall = undefined;
    };
    if (ServerInstall == true) {
        ServerInstall = undefined;
        DateReqServerInstall = undefined;
    };
    ServerRun = false;

}

// Сообщения от приложения
function onNativeMessage(message) {
    //Проверяем наличие
    ServerInstall = true;
    DateReqServerInstall = undefined;
    forConnectPot(message);
}


// Сообщения от страниц
function onConnectPot(Port) {
    if (Port.name == "kkmserver.addin") {
        Port.onMessage.addListener(
            function (message, Port) {

                if (Port.sender != undefined && Port.sender != null && "id" in Port.sender) {
                    if (message.Command == "AddInServerInstall") {
                        ServerHost = localStorage["AddIn.Server"];
                        if (ServerHost == undefined || ServerHost == "") {
                            forKkmServer(undefined, { Command: "AddInGetSettings", Marke: message.Marke }, "AddIn");
                        } else {
                            forKkmServer(undefined, { Command: "AddInGetSettings", Marke: message.Marke });
                        };
                        Port.postMessage({ Command: "AddInServerInstall", ServerInstall: ServerInstall });
                    } else if (message.Command == "AddInStopServer") {
                        if (ServerRun == true) {
                            forKkmServer(undefined, { Command: "Exit" }, "AddIn");
                        };
                    } else {
                        forKkmServer(Port, message);
                    };
                };

            }
        );
    };
}

// Сообщения для страницы
function forConnectPot(message) {
    //Проверяем наличие
    Messages = [];
    if (QueryResponses.has(message.IdCommand) == true) {

        if (message.Command == "TrackingStatusCommand") {

            try {
                MessageHTML = message.MessageHTML;
                message.MessageHTML = undefined;
                // Показываем статус выполнения команды на страничке
                if (MessageHTML != undefined && message.TypeMessageHTM == "TrackingStatus") {
                    // Посылаем сообщение
                    Messages.push(
                        {
                            name: "kkmserver.addin.ShowWindows",
                            MessageHTML: MessageHTML,
                            TypeWindows: "TrackingStatus",
                            IdCommand: message.IdCommand
                        });
                    Port = QueryResponses.get(message.IdCommand);
                    Port.postMessage({ Messages: Messages });
                    // Повторяем трекинг станички
                    RunTrackingStatusCommand(message.IdCommand);
                } else if (MessageHTML != undefined && message.TypeMessageHTM == "TrackingMessage") {
                    Messages.push(
                        {
                            name: "kkmserver.addin.ShowWindows",
                            MessageHTML: MessageHTML,
                            TypeWindows: "ShowMessage",
                            IdCommand: message.IdCommand
                        });
                    Port = QueryResponses.get(message.IdCommand);
                    Port.postMessage({ Messages: Messages });
                };
            } catch (err) { };
        } else if (message.Command == "AddInGetSettings") {
            // Отправляем результат на страницу
            if (message.Command == "AddInGetSettings") {
                message.AddInServerInstall = ServerInstall;
            };
            // Отправляем сообщение
            try {
                Port = QueryResponses.get(message.IdCommand);
                Port.postMessage(message);
                QueryResponses.delete(message.IdCommand);
            } catch (err) { };
        } else {
            try {
                // Закрываем статус выполнения команды на страничке
                Messages.push(
                    {
                        name: "kkmserver.addin.CloseWindows",
                        TypeWindows: "TrackingStatus",
                        IdCommand: message.IdCommand
                    });
                Messages.push(message);
                // Показываем сообщение на страничке
                if (message.MessageHTML != undefined
                    && message.MessageHTML != null
                    && message.MessageHTML != ""
                    && message.TypeMessageHTM == "EndCommand") {
                    MessageHTML = message.MessageHTML;
                    Messages.push(
                        {
                            name: "kkmserver.addin.ShowWindows",
                            MessageHTML: MessageHTML,
                            TypeWindows: "ShowMessage",
                            IdCommand: message.IdCommand
                        });
                }
                message.MessageHTML = undefined;
                message.TypeMessageHTM == undefined;
                // Отправляем сообщение
                Port = QueryResponses.get(message.IdCommand);
                Port.postMessage({ Messages: Messages });
                QueryResponses.delete(message.IdCommand);

            } catch (err) { };
            IsRun = false;
        }

    } else {

        if (message.Command == "GetRezult") {

            try {
                Port = QueryResponses.get(message.Rezult.IdCommand + "GetRezult");
                Port.postMessage(message);
                QueryResponses.delete(message.IdCommand);
            } catch (err) { };
            IsRun = false;

        } else if (message.Command == "AddInShowHtmlInTab") {

            browser.tabs.query({ url: browser.extension.getURL("Check.html") }, function (tabs) {
                if (tabs.length == 0) {
                    //Нет окна, открываем новое
                    browser.tabs.create({ url: browser.extension.getURL("Check.html") },
                        function (tab) {
                            setTimeout(
                                function () {
                                    var Port = browser.runtime.connect({ name: "kkmserver.addin" });
                                    Port.postMessage({ Command: "kkmserver.addin.ShowChek", html: message.html, TabId: tab.id });
                                }, 100
                            );
                        }
                    );
                } else {
                    // Показываем в существующем
                    var Port = browser.runtime.connect({ name: "kkmserver.addin" });
                    Port.postMessage({ Command: "kkmserver.addin.ShowChek", html: message.html, TabId: tabs[0].id });
                    browser.tabs.update(tabs[0].id, { active: true, selected: true });
                };
            });

        } else if (message.Command == "EventBarcode") {

            browser.tabs.query({ active: true, currentWindow: true }, function (tabs) {
                browser.tabs.sendMessage(tabs[0].id, { name: "kkmserver.addin.EventBarcode", message: message }, function (response) { });
            });

        };

    };
}


// отправка на kkmserver
function forKkmServer(Port, message, CurServerHost) {

    // Настройка
    connect();

    message.RunAsAddIn = true;

    // Проверяем что есть идентификатор
    if ("IdCommand" in message == false) {
        message.IdCommand = guid();
    };
    if (message.IdCommand == "") {
        message.IdCommand = guid();
    };

    //Устанавливаем значения по умолчанию
    var IsCommandKKT = (TypeCommand(message.Command) == "Check") ||
        (message.Command == "GetLineLength" || message.Command == "GetDataKKT");

    DefaultKkt = localStorage["AddIn.DefaultKkt"];
    if (IsCommandKKT == true
        && (message.NumDevice == 0 || message.NumDevice == "0" || message.NumDevice == undefined)
        && (message.InnKkm != null && message.InnKkm != "" && message.TaxVariant != null && message.TaxVariant != "")
        && DefaultKkt != "0" && DefaultKkt != 0 && DefaultKkt != undefined) {
        message.NumDevice = DefaultKkt;
    };
    DefaultCashierName = localStorage["AddIn.DefaultCashierName"];
    DefaultCashierVATIN = "";
    if (DefaultCashierName != undefined && DefaultCashierName.indexOf("/") != -1) {
        DefaultCashierVATIN = DefaultCashierName.substring(DefaultCashierName.indexOf("/") + 1).trim();
        DefaultCashierName = DefaultCashierName.substring(0, DefaultCashierName.indexOf("/")).trim();
    };
    if (IsCommandKKT == true
        && (message.CashierName == "" || message.CashierName == undefined)
        && DefaultCashierName != "" && DefaultCashierName != undefined) {
        message.CashierName = DefaultCashierName;
        message.CashierVATIN = DefaultCashierVATIN;
    };

    //Диалоги
    if (message.UseAddInDialogPrintCheck != undefined) {
        if (message.UseAddInDialogPrintCheck == 'false') {
            localStorage["AddIn.UseAddInDialogPrintCheck"] = 'false';
        };
    };
    if (message.UseAddInDialogSelectDevice != undefined) {
        if (message.UseAddInDialogSelectDevice == 'false') {
            localStorage["AddIn.UseAddInDialogSelectDevice"] = 'false';
        };
    };
    CurTypeCommand = TypeCommand(message.Command);
    if (CurTypeCommand != undefined) {
        if (CurTypeCommand == "Check") {
            UseAddInDialogPrintCheck = localStorage["AddIn.UseAddInDialogPrintCheck"];
            if (UseAddInDialogPrintCheck == undefined) {
                UseAddInDialogPrintCheck = true;
            };
            message.UseAddInDialogPrintCheck = UseAddInDialogPrintCheck;
        };
        if (CurTypeCommand != undefined) {
            UseAddInDialogSelectDevice = localStorage["AddIn.UseAddInDialogSelectDevice"];
            if (UseAddInDialogSelectDevice == undefined) {
                UseAddInDialogSelectDevice = true;
            };
            message.UseAddInDialogSelectDevice = UseAddInDialogSelectDevice;
        };
    };

    // Запоминаем порт
    if (Port != undefined) {
        if (message.Command == "GetRezult") {
            QueryResponses.set(message.IdCommand + "GetRezult", Port);
        } else {
            QueryResponses.set(message.IdCommand, Port);
        };
    };

    // Ставим на мониторинг команду
    if (TypeCommand(message.Command) != undefined) {
        RunTrackingStatusCommand(message.IdCommand);
    };

    // Выполняем команду
    if (CurServerHost == undefined) {
        ServerHost = localStorage["AddIn.Server"];
        CurServerHost = ServerHost;
    };
    if (CurServerHost == "AddIn") {

        if (ServerRun == false) {
            connect();
        };

        try {
            Error = "";
            if (DateReqServerInstall == undefined) {
                DateReqServerInstall = new Date();
            };
            PortServer.postMessage(message);
        } catch (ex) {
            if (ServerInstall == undefined && DateReqServerInstall != undefined && (new Date() - DateReqServerInstall) >= 5000) {
                ServerInstall = false;
                DateReqServerInstall = undefined;
            };
            //
            Error = ex.message;
            ServerInstall = false;
            //
            forConnectPot({
                Command: message.Command,
                Error: "Ошибка расширения: " + ex.message,
                Status: 2,
                IdCommand: message.IdCommand,
            });
            // Заново запускаем сервер
            ServerRun = false;
            connect();
        };

    } else if (CurServerHost == "none") {

        forConnectPot({
            Command: message.Command,
            Error: "Расширение браузера kkmserver не настроенно!",
            Status: 2,
            IdCommand: message.IdCommand,
        });

    } else {

        var JSon = JSON.stringify(message);

        User = localStorage["AddIn.User"];
        if (User == undefined) {
            User = "Admin";
        };
        Pass = localStorage["AddIn.Pass"];

        TimeOut = 60000;
        try {
            if (message.Timeout != undefined && message.Timeout > 1) {
                TimeOut = (message.Timeout + 20) * 1000
            };
        } catch (ex) {
        };


        var HeaderAuthorization = (User !== '' || Pass !== '') ? ('Basic ' + btoa(User + ':' + Pass)) : '';
        var IsRerror = false;
        const response = fetch(
            CurServerHost + '/Execute',
            {
                method: 'POST', // *GET, POST, PUT, DELETE, etc.
                mode: 'cors', // no-cors, *cors, same-origin
                cache: 'no-cache', // *default, no-cache, reload, force-cache, only-if-cached
                //credentials: 'same-origin', // include, *same-origin, omit
                headers: {
                    'Content-Type': 'application/json; charset=UTF-8',
                    'Authorization': HeaderAuthorization
                },
                redirect: 'follow', // manual, *follow, error
                referrerPolicy: 'no-referrer', // no-referrer, *client
                body: JSon
            }
        ).catch(Exception => {
            IsRerror = true;
            var TextError = "";
            forConnectPot({
                Command: message.Command,
                Error: "Ошибка: " + Exception.message,
                Status: 2,
                IdCommand: message.IdCommand,
            });
        }).then(response => {
            if (IsRerror == false) {
                response.json(
                ).catch(Exception => {
                    IsRerror = true;
                    forConnectPot({
                        Command: message.Command,
                        //Error: textStatus + ": " + Exception.message,
                        Error: "Ошибка: " + Exception.message,
                        Status: 2,
                        IdCommand: message.IdCommand,
                    });
                }).then(resultJson => {
                    if (IsRerror == false) {
                        forConnectPot(resultJson);
                    };
                });
            };
        });

    };

};

// Мониторим команду на сообщения для показа на экране
function RunTrackingStatusCommand(IdCommand) {

    let timerId = setInterval(() => {

        Port = QueryResponses.get(IdCommand);
        if (Port == undefined) {
            clearInterval(timerId);
            TrackingStatus.delete(IdCommand);
            return;
        };
        TrackingStatus.set(IdCommand);
        CommandShowMessage = {
            Command: "TrackingStatusCommand",
            IdCommand: IdCommand
        };
        forKkmServer(undefined, CommandShowMessage);

    }, 1000);


}

// Мониторим команду на сообщения для показа на экране
function TypeCommand(Command) {

    //Устанавливаем значения по умолчанию
    if (Command == "RegisterCheck"
        || Command == "OpenShift"
        || Command == "CloseShift"
        || Command == "XReport"
        || Command == "ZReport"
        || Command == "DepositingCash"
        || Command == "KkmRegOfd") {
        return "Check";
    };

    if (Command == "PaymentCash"
        || Command == "KkmRegOfd"
        || Command == "PayByPaymentCard"
        || Command == "ReturnPaymentByPaymentCard"
        || Command == "CancelPaymentByPaymentCard"
        || Command == "AuthorisationByPaymentCard"
        || Command == "AuthConfirmationByPaymentCard"
        || Command == "CancelAuthorisationByPaymentCard"
        || Command == "EmergencyReversal"
        || Command == "TerminalReport"
        || Command == "TransactionDetails"
        || Command == "Settlement") {
        return "Pay";
    }

    if (Command == "PrintDocument") {
        return "Print";
    }

    if (Command == "GetWeight") {
        return "Libra";
    }


    return undefined;

}

///////////////////////////////////////////////////////////////////////////
//  Связь с приложениями
///////////////////////////////////////////////////////////////////////////

// Герерация GUID
function guid() {

    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
}

function ShowHtmlInTab(Url) {

    browser.tabs.create({ url: browser.extension.getURL(Url) });

}

///////////////////////////////////////////////////////////////////////////
//  Страница настроек
///////////////////////////////////////////////////////////////////////////

function onBeforeRequest(details) {
    if (details.url.toLowerCase().indexOf("localhost:5893") != -1 && details.url.indexOf("https") != -1) {
        return { redirectUrl: details.url.replace('https', 'http') };
    } else {
        return {};
    }
}

function onErrorOccurred(details) {
    return {};
}

function onCompleted(details) {
    return {};
}

